/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz.views.components;

import java.time.Year;
import javax.swing.AbstractSpinnerModel;

public class YearSpinnerModel extends AbstractSpinnerModel {

  private int value;
  private String showingValue;

  public YearSpinnerModel() {
    this.value = Year.now().getValue();
    this.showingValue = String.valueOf(value);
  }

  @Override
  public Object getValue() {
    return this.showingValue;
  }

  @Override
  public void setValue(Object value) {
    this.showingValue = String.valueOf(value);
    this.value = Integer.parseInt(this.showingValue);
  }

  @Override
  public Object getNextValue() {
    if (this.value == 9999) {
      return null;
    }

    if (this.value > 9999) {
      this.value = 9999;
      this.showingValue = String.valueOf(this.value);
    } else if (this.value < 0) {
      this.value = 0;
      this.showingValue = String.valueOf(this.value);
    } else {
      this.value++;
      this.showingValue = String.valueOf(value);
    }

    this.fireStateChanged();
    return this.showingValue;
  }

  @Override
  public Object getPreviousValue() {
    if (this.value == 0) {
      return null;
    }

    if (this.value > 9999) {
      this.value = 9999;
      this.showingValue = String.valueOf(this.value);
    } else if (this.value < 0) {
      this.value = 0;
      this.showingValue = String.valueOf(this.value);
    } else {
      this.value--;
      this.showingValue = String.valueOf(value);
    }

    this.fireStateChanged();
    return this.showingValue;
  }
}
